module numbertheory

  implicit none

contains

  function gcd(a, b) ! Greatest Common Divisor
    integer :: gcd
    integer, intent(in) :: a, b
    integer :: gb, t

    gcd = abs(a)
    gb = abs(b)

    if (a == 0) gcd = gb 
    if (a == 0 .or. b == 0) return 

    do
      t = mod(gcd, gb)
      gcd = gb
      if (t == 0) exit
      gb = t
    end do

  end function gcd

  function lcm(a, b) ! Least Common Multiple
    integer :: lcm
    integer, intent(in) :: a, b

    if (a == 0 .and. b == 0) then 
      lcm = 0 ; return 
    end if 

    lcm = a*(b/gcd(a,b))

  end function lcm

end module numbertheory
